<?php

namespace App\Http\Dao;

use App\Models\Order;

class OrderDao extends Order
{
    /**
     * 查找订单号的单条记录
     * @param array $where
     * @return mixed
     */
    public function getFirstRecord(array $where)
    {
        return Order::where($where)
            ->first();
    }

    /**
     * 查找订单号的单条记录
     * @param array $where
     * @return mixed
     */
    public function getFirstRecordByStr(string $where)
    {
        return Order::where($where)
            ->first();
    }

    /**
     * 插入单条记录
     *
     * @param array $data
     * @return mixed
     */
    public function insertData(array $data)
    {
        return self::insert($data);
    }

    /**
     * 通过id进行记录更新
     *
     * @param int   $id
     * @param array $updateData
     * @return mixed
     */
    public function updateById(int $id, array $updateData)
    {
        return self::where('id', $id)->update($updateData);
    }
}
